package Aplpl::VALUE;
use strict;

use Scalar::Util qw(weaken);
use Aplpl::PAIR;
use Exporter;
use vars qw(@ISA @EXPORT);

@ISA = ("Exporter");
@EXPORT = qw(&newVAL &vcons &vlcons);

sub vcons {
   my ($hd, $tl)=@_;
   return newVAL('PAIR', $hd, $tl);
}

sub vlcons {
   my ($hd, $tl)=@_;
   if ($hd->('type') eq 'VAL') { 
      return bless([$hd, $tl], 'Aplpl::PAIR');
   }
   else {
      print "vlcons: invalid argument type type!<br>\n";
   }
};


sub newVAL {
   my $type  = 'VAL';
   my $vtype = shift;
   my $value;

   if ($vtype eq 'INT') {
      $value = shift;
   }
   elsif ($vtype eq 'DBL') {
      $value = shift;
   }
   elsif ($vtype eq 'SYM') {
      $value = shift;
   }
   elsif ($vtype eq 'STR') {
      $value = shift;
   }
   elsif ($vtype eq 'PAIR') {
      my $hd = shift;
      my $tl = shift;
      if (($hd->('type') eq 'VAL'  && $hd->('vtype') eq 'PAIR') &&
          ($tl->('type') eq 'VAL'  && $tl->('vtype') eq 'PAIR')) {
         $value =  bless([$hd, $tl], 'Aplpl::PAIR');
      }
      else {
         print "invalid argument type!\n";
      }
   }
   elsif ($vtype eq 'ACL') {
      my $fun = shift;
      my $env = shift;
      weaken($env);
      $value  = cons($fun, $env);
   }
   elsif ($vtype eq 'THUNK') {
      my $body = shift;
      my $env  = shift;
      weaken($env);
      $value   = cons($body, $env);
   }
   elsif ($vtype eq 'PRIM') {
      $value   = shift;
   }
   else {
      print "invalid value type!\n";
   }

   my $objref     = sub {
                         my $msg = shift;
                         if ($msg eq 'type') {
                            return $type;
                         } 
                         elsif ($msg eq 'vtype') {
                            return $vtype;
                         } 
                         elsif ($msg eq 'value') {
                            return $value;
                         } 
                         elsif ($msg eq 'setval') {
                            my $arg = shift;
                            $value = $value + $arg;
                            return $value;
                         } 
                         else {
                            print ("VALUE: message unknown: $msg <br>");
                         }
                    };
   return (bless($objref, 'Aplpl::VALUE'));
}

1;
